image: python:3.8

variables:
  ARTIFACT_DIR: "./archive"
  ARTIFACT_NAME: "backend.tar"
  STORAGE_DRIVER: "vfs"
  BUILDAH_FORMAT: "docker"
  POSTMAN_COLLECTION: https://api.getpostman.com/collections/${c_uid}?apikey=${apiKey}
  POSTMAN_ENVIRONMENT: https://api.getpostman.com/environments/${e_uid}?apikey=${apiKe

before_script:
  - pip install pipenv
  - pipenv install --system --deploy --ignore-pipfile
  - pipenv --clear
  - pip install flake8 safety
  - pip freeze

stages:
  - Security
  - Static Analysis
  - Test
  - Build
  
safety:
  stage: Security
  script:
    - safety check

gitleaks:
  stage: Security
  before_script:
    - ''
  image: 
    name: "zricethezav/gitleaks"
    entrypoint: [""]
  script:
     - gitleaks --source . --verbose

flake8:
  stage: Static Analysis
  script:
    - flake8 --max-line-length 120 --max-complexity 10 WeatherSound

postman:
  stage: Test
  only:
    - merge_request
  image:
    name: postman/newman
    entrypoint: [""]
  before_script:
    - ''
  script:
    - newman --version
    - npm install -g newman-reporter-html
    - newman run collection.json --reporters cli,html --reporter-html-export report.html
  artifacts:
    when: always
    paths:
      - report.html

hadolint:
  stage: Static Analysis
  before_script:
    - ''
  image: hadolint/hadolint:latest-debian
  script:
    - hadolint Dockerfile
    
  

build:
  stage: Build
  only:
    - merge_request
    - main
  before_script:
    - export TAG="${CI_COMMIT_TAG:-latest}" && echo $TAG
  image: docker:latest
  services:
    - docker:dind
  variables:
    IMAGE_TAG: $CI_REGISTRY_IMAGE:latest
  before_script:
     - echo "$CI_REGISTRY_PASSWORD" | docker login -u "$CI_REGISTRY_USER" "$CI_REGISTRY" --password-stdin
  script:
    - docker build -t $IMAGE_TAG .
    - docker push $IMAGE_TAG
  dependencies:
    - build
